
/*
 * `Minimize' two similar files containg text and numbers.
 *
 * Files should be textually identical apart from numeric fields.
 * Smallest value of each corresponding numeric field appears in output.
 *
 * "Bugs"
 *   Negative numbers are not recognized.
 *   Numeric fields *beginning* with a decimal point are not recognized.
 *   All numbers are output using `%f' format (even if sources contain whole
 *       numbers).
 *   All argument files are held open concurrently (uses many fd's).
 *
 */

#include <stdio.h>
#include <stdlib.h>

inline double min(double x, double y) { return x <= y ? x : y ; }

int main(int argc, char** argv) {
  FILE* f1 = fopen(argv [1], "r") ;

  const int C = argc - 2 ;
  FILE** fs = new FILE* [C] ;

  int i ;

  for(i = 0 ; i < C ; i++)
    fs [i] = fopen(argv [2 + i], "r") ;

  int c ;

  while((c = fgetc(f1)) != EOF) {
    if('0' <= c && c <= '9') {
      ungetc(c, f1) ;
      double x ;
      int n = fscanf(f1, "%lf", &x) ;
      if(n == 1) {
	for(i = 0 ; i < C ; i++) {
	  double y ;
	  int m = fscanf(fs [i], "%lf", &y) ;
	  if(m == 1)
            x = min(x, y) ;
	  else {
	    fprintf(stderr, "File %s is not similar (expecting number)\n",
                    argv [2 + i]) ;
	    exit(1) ;
	  }
        }
	//printf("%f", x) ;
	printf("%e", x) ;
      }
      else {
        fprintf(stderr,
                "Parse failure: character \'%c\' must start a number.\n", c) ;
        exit(1) ;
      }
    }
    else {
      for(i = 0 ; i < C ; i++)
        if(fgetc(fs [i]) != c) {
	  fprintf(stderr, "File %s is not similar (expecting \'%c\')\n",
                  argv [2 + i], c) ;
	  exit(1) ;
        }
      printf("%c", c) ;
    }
  }

  for(i = 0 ; i < C ; i++)
    if(fgetc(fs [i]) != EOF) {
      fprintf(stderr, "File %s is not similar (expecting EOF)\n",
              argv [2 + i]) ;
      exit(1) ;
    }
}

